<template>
  <div>
    <p class="text-xl font-semibold py-6 px-8 border-b">Check your Hardware</p>
    <div class="py-6 px-8">
      <div class="flex space-x-5 w-full">
        <CdxButton @click="getAudioStream()"> Reopen the permission popup </CdxButton>

        <div v-if="!isVideoRecording">
          <CdxButton
            v-if="microphoneTestState === 'init'"
            :disabled="permissionDenied"
            weight="primary"
            action="progressive"
            @click="recordMicrophoneTest()"
          >
            Test your microphone!
          </CdxButton>
          <div v-else-if="microphoneTestState === 'record'">Recording...</div>
          <div v-else-if="microphoneTestState === 'play'">Listening...</div>
          <div v-else-if="microphoneTestState === 'wait'">Waiting...</div>
        </div>
        <div v-else>
          <video v-if="!videoError" ref="video" class="h-[300px] mt-4" autoplay></video>
        </div>
      </div>
      <CdxMessage
        v-if="permissionDenied || videoError"
        class="mt-5"
        type="error"
        dismiss-button-label="Close"
        fade-in
      >
        <p><b>Permission to use the microphone or camera was denied.</b></p>
        <p>
          Please give permission before continuing, or ensure you have a microphone or camera
          connected to your device.
        </p>
        <img src="/hardware_check_image.png" class="max-h-64 mt-3">
      </CdxMessage>
    </div>
  </div>
</template>

<script setup>
import { LinguaRecorder } from 'lingua-recorder'
import { CdxButton, CdxMessage } from '@wikimedia/codex'
import { onMounted, onUnmounted, ref } from 'vue'
import { signLanguages } from '../utils/data'
import { useRecordWizardStore } from '@/stores/recordwizard'

const emit = defineEmits(['canGoToNextStep', 'canNotGoToNextStep'])

const store = useRecordWizardStore()
const isVideoRecording = Object.values(signLanguages).includes(store.selectedLanguageId)
const video = ref(null)
const videoError = ref(false)

let recorder = null // either instance of LinguaRecorder or null (reinstanciating allows to reask for permission)
const microphoneTestState = ref('init') // init -> wait -> record -> wait -> play ⟲
let recorderStopTimeout = null // either null or timeout of the recorder to avoid having it run indefinitely
const permissionDenied = ref(false)

const showError = function (mediaStreamError) {
  // This can happen if the browser refused to ask for the microphone permission
  // or if the user blocked us from using the mic or camera
  console.log('Could not load the Recorder')
  console.log(mediaStreamError)
  permissionDenied.value = true
}

const unloadRecorder = function () {
  if (!recorder) {
    return
  }

  recorder.stop()
  recorder.off('readyFail')
  recorder.off('ready')
  recorder.off('stopped')
  recorder.close()
  recorder = null
}

const getAudioStream = function () {
  // Make sure any currently active recorder is disabled
  unloadRecorder()

  recorder = new LinguaRecorder({
    autoStart: true,
    autoStop: true,
  })

  // disable the error message
  permissionDenied.value = false

  recorder.on('readyFail', showError)
  recorder.on('ready', () => recorder.on('stopped', playMicrophoneTest))
}

let stream = null

const getWebCam = async () => {
  try {
    stream = await navigator.mediaDevices.getUserMedia({
      audio: true,
      video: true,
    })
    video.value && (video.value.srcObject = stream)
  } catch (err) {
    videoError.value = true
    console.error('[VideoRecorder]', err.name, err.message)
  }
}

const stopWebCam = () => {
  if (stream) {
    stream.getTracks().forEach((track) => track.stop())
    stream = null
  }
}

const playMicrophoneTest = function (record) {
  microphoneTestState.value = 'wait'

  setTimeout(() => {
    microphoneTestState.value = 'play'
    clearTimeout(recorderStopTimeout)

    const audioNode = record.getAudioElement()
    audioNode.play()

    setTimeout(
      () => {
        microphoneTestState.value = 'init'

        // Microphone has been tested, so we can go to the next step
        emit('canGoToNextStep')
      },
      record.getDuration() * 1000 + 300,
    )
  }, 1100)
}

const recordMicrophoneTest = function () {
  microphoneTestState.value = 'wait'

  setTimeout(() => {
    microphoneTestState.value = 'record'
    recorder.start()
    recorderStopTimeout = setTimeout(recorder.stop.bind(recorder), 8000)
  }, 1100)
}

onMounted(() => {
  getAudioStream()
  isVideoRecording && getWebCam()
  isVideoRecording && emit('canGoToNextStep')
})
onUnmounted(() => {
  unloadRecorder()
  isVideoRecording && stopWebCam()
})
</script>
